require 'khttpsv_simple.rb'

class Sample_server < Khttpsv_simple
  #----------------------------------------------------------------------
  def allow?(a)
    return true if a == 'cgi_exec'
    return super
  end

  #----------------------------------------------------------------------
  def Khttpsv_template.logger(s, lev = LOG_INFO)
    pri = nil
    case lev
    when LOG_NOTICE
      pri = 'local0.notice'
    when LOG_WARN
      pri = 'local0.warning'
    when LOG_ERR
      pri = 'local0.error'
    end
    if pri then
      system('logger', '-t', 'khttpsv', '-p', pri, "#{Thread.current.id}: #{s}")
    end
    STDERR.print "#{Thread.current.id}: #{s}\n"
  end

  #----------------------------------------------------------------------
  def get_server_addr
    # name-based virtual hosting
    if @req_headers['Host'] then
      if @req_headers['Host'][0] =~ /^sakura:/i then
	return 'sakura'
      elsif @req_headers['Host'][0] =~ /^vmgateway:/i then
	return 'vmgateway'
      end
    end
    return 'www.default.co.jp'
  end

  def get_server_addr_ip
    # IP-based virtual hosting
    if @sock.addr[3] == '127.0.0.1' then
      return 'sakura'
    elsif @sock.addr[3] == '192.168.2.1' then
      return 'vmgateway'
    else
      return 'www.default.co.jp'
    end
  end

  #----------------------------------------------------------------------
  def document_root
    # virtual hosting
    case @server_addr
    when 'sakura'
      return '/var/www/dir1'
    when 'vmgateway'
      return '/var/www/dir2'
    else
      return '/var/www'
    end
  end

  #----------------------------------------------------------------------
  def hook_translate_path(s)
    if s.sub!(%r{^/cgi-bin/}, '/usr/lib/cgi-bin/') then
      # translate uri into path, for exapmle
      # http://server/cgi-bin/foo/bar.cgi -> /usr/lib/cgi-bin/foo/bar.cgi
      return s
    end
    return super
  end

  #----------------------------------------------------------------------
  def initialize(s)
    super
    @server_name = 'MyPrivateServer/2.2.16'
    # @index_file = 'welcome.html'
    # @user_document_dir = '.www_doc'
    @loglevel = LOG_DEBUG # override
  end
end

Sample_server.start(8080)
