require 'khttpsv_simple.rb'

class Sample_server < Khttpsv_simple
  #----------------------------------------------------------------------
  def allow?(a)
    return true if a == 'cgi_exec'
    return super
  end

  #----------------------------------------------------------------------
  def get_server_addr_name
    # name-based virtual hosting
    if @req_headers['Host'] then
      if @req_headers['Host'][0] =~ /^www.domain1.co.jp:/i then
	return 'www.domain1.co.jp'
      elsif @req_headers['Host'][0] =~ /^www.domain2.co.jp:/i then
	return 'www.domain2.co.jp'
      end
    end
    return 'www.default.co.jp'
  end

  def get_server_addr_ip
    # IP-based virtual hosting
    if @sock.addr[3] == '192.168.2.1' then
      return 'www.domain1.co.jp'
    elsif @sock.addr[3] == '192.168.2.2' then
      return 'www.domain2.co.jp'
    else
      return 'www.default.co.jp'
    end
  end

  #----------------------------------------------------------------------
  def document_root
    # virtual hosting
    case @server_addr
    when 'www.domain1.co.jp'
      return '/var/www/dir1'
    when 'www.domain2.co.jp'
      return '/var/www/dir2'
    else
      return '/var/www'
    end
  end

  #----------------------------------------------------------------------
  def hook_translate_path(s)
    if s.sub!(%r{^/cgi-bin/}, '/usr/lib/cgi-bin/') then
      # translate uri into path, for exapmle
      # http://server/cgi-bin/foo/bar.cgi -> /usr/lib/cgi-bin/foo/bar.cgi
      return s
    end
    return super
  end

  #----------------------------------------------------------------------
  def initialize(s)
    super
    @server_name = 'MyPrivateServer/2.2.16'
    # @index_file = 'welcome.html'
    # @user_document_dir = '.www_doc'
    # @loglevel = LOG_DEBUG # override
  end
end

Sample_server.start(8080)
